/*
 *  Part of rvglue source code,
 *  Copyright (C) 2000 Alexander Kroeller (alilein@gmx.de)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __OPTKEEP_H
#define __OPTKEEP_H

#include "optset.h"
#include "parser.h"


#define MAX_FOPTS  200


#define DEFAULT_GROUP "default"

class OptionSetKeeper
{
public:
  OptionSetKeeper(OptionSetKeeper *_parent=NULL);
  ~OptionSetKeeper();

  int read(Parser &p);
  int readpart(Parser &p);

  OptionSet *lookup(const char *iname, bool useDefaults=true);

private:
  OptionSetKeeper *parent;

  char *inames[MAX_FOPTS];
  OptionSet *optsets[MAX_FOPTS];
  int cursize;
};


#endif
