/*
 *  Part of rvglue source code,
 *  Copyright (C) 2000 Alexander Kroeller (alilein@gmx.de)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __PARSER_H
#define __PARSER_H

#include <stdarg.h>

#define PT_EOF     1
#define PT_WHITE   2
#define PT_BBEGIN  3
#define PT_BEND    4
#define PT_TEXT    5
#define PT_CBEGIN  6
#define PT_CEND    7
#define PT_LINECOM 8

#define MAX_TOK_LENGTH 50

class Parser
{
public:
  Parser(const char *_fname);
  ~Parser();

  void error(int errnum, const char *args, ...);

  int curtok;
  char tok_text[MAX_TOK_LENGTH];

  void gentoken(void);

private:
  int gchar(void);
  void push(void);
  int type(int);

  void skipwhite(void);

private:
  char *fname;
  FILE *f;
  int lineno, curch;
};

#endif
