/*
 *  Part of rvglue source code,
 *  Copyright (C) 2000 Alexander Kroeller (alilein@gmx.de)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __POLYGON_H
#define __POLYGON_H

#include "rvtypes.h"



#define TEP_PWALL      1
#define TEP_RWALL      2
#define TEP_CARIMG     4
#define TEP_FLOOR      8
#define TEP_LAMP      16
#define TEP_BOX       32
#define TEP_TRACK     64



class Polygon
{
public:
  Polygon(RV_Poly *);
  Polygon(FILE *);

  void setTransparency(rvulong);

  int numverts(void);

  void setTEColor(rvulong);

  void write(FILE *);

  int detTEPart(void);

  bool isInTexture(rvshort page, rvfloat ulo, rvfloat uhi, rvfloat vlo, rvfloat vhi);

  int vertidx(int);

  /*  Polygon(int npoints, Vertex[], rvulong *cols=NULL);
  Polygon(int npoints, Vector[], rvulong *cols=NULL);
  
  void setSimpleColor(rvulong col);
  void setColor(int, rvulong col);
  void makeFlatNormals(void);

  void write(FILE *f, VertList &);

  int numverts(void);

  Vertex &point(int idx); // flips around!

  void print(FILE *); */

private:
  bool teheur_BlueWall(void);
  bool teheur_Lamp(void);
  bool teheur_Floor(void);
  bool teheur_RWall(void);
  bool teheur_Box(void);
  bool teheur_CarImage(void);

  RV_Poly data;
};


#endif
