/*
 *  Part of rvglue source code,
 *  Copyright (C) 2000 Alexander Kroeller (alilein@gmx.de)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "print.h"


int msglevel;


time_t last_percent_tt=(time_t)0;



void lprintf(int level, const char *args, ...)
{
  va_list ap;

  va_start(ap, args);  
  if(msglevel>=level)
    vprintf(args, ap);
  va_end(ap);
}

void lprintff(int level, const char *args, ...)
{
  va_list ap;

  va_start(ap, args);  
  if(msglevel>=level)
    {
      vprintf(args, ap);
      fflush(stdout);
    };
  va_end(ap);
}


void xpanic(const char *args, ...)
{
  va_list ap;

  printf("\nPANIC: ");
  va_start(ap, args);  
  vprintf(args, ap);
  va_end(ap);
  printf("\n");

  printf("  You encountered a program bug.\n");
  printf("  Look whether there is a newer version of this program available,\n");
  printf("  where this bug is fixed.\n\n");
  printf("  If not, try to send an eMail to\n");
  printf("    alilein@gmx.de\n");
  printf("  and include\n");
  printf("   1. all input files you used for this track\n");
  printf("   2. the command file you used\n");
  printf("   3. the message that stands above behind 'PANIC'\n");
  printf("   4. the program version you use ('%s')\n\n",APPVERSION);
  printf("  The files this program created are most likely waste.\n");
  exit(127);
}





void showPercent(int level, int now, int total, int &last)
{
  int act=(now*100)/total;
  int curt=time(NULL);

  if((act > last) && (curt != last_percent_tt))
    {
      lprintff(level, "\r  %3d %%   ",act);
      last_percent_tt=curt;
      last=act;
    };
}

void doneShowPercent(int level)
{
  lprintff(level, "\r           \r");
}
