/*
 *  Part of rvglue source code,
 *  Copyright (C) 2000 Alexander Kroeller (alilein@gmx.de)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __VERTEX_H
#define __VERTEX_H

#include "rvtypes.h"

class Vertex
{
public:
  Vertex();  // empty, x=y=z=0
  Vertex(RV_Vertex*);    // copy from rv-mem-data
  Vertex(FILE *);        // read from binary file


  void translate(rvfloat dx, rvfloat dy, rvfloat dz);
  void rotate(rvfloat[3][3]);

  void write(FILE *);

  /*
  Vertex(Vertex &);      // copy from other vector

  Vertex(Vector, Vector);

  Vertex(rvfloat x, rvfloat y, rvfloat z,
	 rvfloat u, rvfloat v, rvfloat w); // spec. x,y,z,u,v,w

  bool   operator == (Vertex &);
  bool   operator != (Vertex &);

  Vector &pos(void);
  Vector &normal(void);

  void write(FILE *);

  void print(FILE *);
  void print_xyz(FILE *);
  void print_uvw(FILE *);
  void print_pov(FILE *);
  */

  RV_Vertex data;
};

#endif
